#ifndef synaps_arithm_binomial_h
#define synaps_arithm_binomial_h

#include <synaps/init.h>

__BEGIN_NAMESPACE_SYNAPS

/** Binomial coefficients **/
template <typename T>  T binomial(int n, int p)
{
  T n1=1;

  if(p!=0)
    {
      if((n-p)<p) p=n-p;
      int n2=n;
      for(int i=1;i<=p;i++,n2--) n1=n1*n2/T(i);
    }

  return(n1);
}

__END_NAMESPACE_SYNAPS

#endif // synaps_arithm_binomial_h

