#ifndef SYNAPS_ARITHM_TRAITS_FLOATINGOF_H
#define SYNAPS_ARITHM_TRAITS_FLOATINGOF_H

#include <synaps/arithm/traits/kernelof.h>

__BEGIN_NAMESPACE_SYNAPS

namespace arithm {

  template<class X>
  struct floatingof_ { typedef double T; };
  template<class K, class X>
  struct kernel_floatingof { typedef typename K::floating T; };
  template<class X>
  struct kernel_floatingof<null_t,X> { typedef typename floatingof_<X>::T T; };
  template<class X>
  struct floatingof
  {
    typedef typename ucstref<X>::T _X;
    typedef typename kernel_floatingof< typename kernelof<X>::T, _X  >::T T;
  };

}

__END_NAMESPACE_SYNAPS 

#endif
