#ifndef SYNAPS_ARITHM_TRAITS_HASPROPERTY_H
#define SYNAPS_ARITHM_TRAITS_HASPROPERTY_H

#include "isexact.h"
#include "isring.h"
#include "isfield.h"

__BEGIN_NAMESPACE_SYNAPS

namespace arithm {
  
  template< typename X >
  struct hasproperty
  {
    typedef typename isexact< X >::T  exact;
    typedef typename isring < X >::T  ring;
    typedef typename isfield< X >::T  field;
  }; 

}

__END_NAMESPACE_SYNAPS

#endif
