#ifndef SYNAPS_ARITHM_TRAITS_IEEEOF_H
#define SYNAPS_ARITHM_TRAITS_IEEEOF_H

#include <synaps/arithm/traits/kernelof.h>

__BEGIN_NAMESPACE_SYNAPS

namespace arithm
{
  template<class X>
  struct ieeeof_ { typedef double T; };
  
  template<class K, class X>
  struct kernel_ieeeof { typedef typename K::ieee T; };
  template< class X>
  struct kernel_ieeeof<null_t, X > { typedef typename ieeeof_<X>::T T; };
  
  template<class X>
  struct ieeeof
  {
    typedef typename ucstref<X>::T   _X;
    typedef typename kernel_ieeeof< typename kernelof<X>::T, _X  >::T T;
  };
}

__END_NAMESPACE_SYNAPS

#endif  
