#ifndef SYNAPS_ARITHM_TRAITS_SUP_H
#define SYNAPS_ARITHM_TRAITS_SUP_H

#include <synaps/arithm/traits/issubsetof.h>

__BEGIN_NAMESPACE_SYNAPS

namespace arithm {

template<typename X, typename Y>
struct sup_ 
{
  typedef X T;
};

//  template<typename X> struct sup_<X,X> { typedef X T; };
template<class X,class Y> struct sup;

template<typename X, typename Y>
struct sup
{
  typedef typename ucstref<X>::T _X;
  typedef typename ucstref<Y>::T _Y;
  typedef typename issubsetof< X, Y >::T TA;
  typedef typename issubsetof< Y, X >::T TB;
  typedef typename tselect< TA, Y, null_t >::T A;
  typedef typename tselect< TB, X, null_t >::T B;
  typedef typename sup_<_X,_Y>::T C;
  typedef typename sfirstnn< C, A, B >::T T;
};

}

__END_NAMESPACE_SYNAPS

#endif
