# include <synaps/shape/interfaces/IRationalSurface.h>
# include <synaps/shape/surfaces/MPDRationalSurface.h>


int main(int argc, char** argv) 
{
  using std::cout;
  using std::endl;
  MPolDseRationalSurface<double> s1, s2;

  s1.setEquations("s^2+t^2+1", "s-1+t^2", "s^2", "t^2", "s t");
  s1.setRange(-1, 1, -1, 1);

  s2.setEquations("s^2+t^2+1", "s*t-1", "t^2", "1-s^2", "s t");
  s2.setRange(-1, 1, -1, 1);

  cout<<s1<<endl;
  cout<<s2<<endl;

}
