/*********************************************************************
*      This file is part of the source code of SYNAPS kernel.        *
*   Author(s): B. Mourrain, GALAAD, INRIA                            *
**********************************************************************
$Id: linalg.h,v 1.2 2005/07/11 12:01:55 jppavone Exp $
**********************************************************************/
#ifndef SYNAPS_LINALG_H
#define SYNAPS_LINALG_H


#ifdef HAVE_CONFIG_H
	#include <synaps/config.h>
#endif

#include <synaps/init.h>

#define WITH_IO
//----------------------------------------------------------------------
#include <complex>
#include <synaps/base/io/maple.h>
#include <synaps/linalg/VectDse.h>
#include <synaps/linalg/MatrDse.h>
#include <synaps/linalg/MatrStr.h>
#include <synaps/linalg/MatrSps.h>
#include <synaps/linalg/Eigen.h>
#include <synaps/linalg/Svd.h>
#include <synaps/linalg/Solve.h>
#include <synaps/linalg/Decomp.h>
#include <synaps/linalg/Uschur.h>
#include <synaps/linalg/Det.h>
#include <synaps/linalg/Rank.h>
//----------------------------------------------------------------------
#include <synaps/linalg/rep1d.h>
#include <synaps/linalg/rep2d.h>
#include <synaps/linalg/lapack.h>
#include <synaps/linalg/sym2d.h>
//#include <synaps/linalg/lapack_sym2d.h>
//#include <synaps/linalg/maple.h>
//#include <synaps/linalg/hankel.h>
//#include <synaps/linalg/toeplitz.h>
//----------------------------------------------------------------------

#endif // SYNAPS_LINALG_H

