#ifndef LAPACK_EXTERN_SYM2D_H
#define LAPACK_EXTERN_SYM2D_H

//----------------------------------------------------------------------
#include "synaps/util/f2c.h"

#ifdef HAVE_CONFIG_H
	#include <synaps/config.h>
#endif

#include "synaps/util/f2c.h"

#ifndef F77NAME
	#ifdef F77_FUNC
		#define F77NAME(x) F77_FUNC(x,x)
	#else
		#define F77NAME(x) x##_
	#endif
#endif

//----------------------------------------------------------------------
extern "C" 
{
  double F77NAME(dlamch)(char * C);

  void F77NAME(dsytrf)(integer *M, integer *N, doublereal *A, integer *lda,
		       integer *jpvt, doublereal *tau, doublereal *work, 
		       integer *info);
}
//----------------------------------------------------------------------


#endif // LAPACK_EXTERN_SYM2D_H

