#define USING_NAMESPACE_SYNAPS 1

#include "synaps/linalg/VectDse.h"

typedef VectDse<double> vect_t;
  // VectDse definition based on array1d container, with double coefficients.

int main(int argc, char** argv) 
{
  using std::cin;
  using std::cout;
  using std::endl;

  vect_t U(4,"0 2 1 3"), V(4,"1 2 3 4"), W;

  cout<<"U="<<U<<", V ="<<V<<endl;
  cout<<V*2 << ", " << V/4<<endl;

  // The operations are performed only when the result is assigned 
  // to a variable.
  V *= 2;    cout<<V<<endl;
  V /= 4;    cout<<V<<endl;

  V += V;    cout<<V<<endl;
  U-=(V+V);  cout<<U<<endl;
  W=U+V;     cout<<W<<endl;
  W=V*2;     cout<<W<<endl;
  W=W*2-3*U; cout<<W<<endl;
  W = V; V[2]= -1;  cout<<W << ", " << V<<endl;
  W= V[Range(1,2)]; cout<<W<<endl;
  V[Range(1,2)]=Eval(U[Range(2,3)]);    cout <<V<<endl;
  assert(V[1]==U[2]);  assert(V[2]==U[3]);
  //V[Range(1,2)]=Eval(U[Range(2,3)]/5);  cout <<V<<endl;

}

