#include <synaps/mpol.h>

typedef MPol<double> mpol_t;
typedef mpol_t::monom_t mon_t;

int main (int argc, char **argv)
{
  using namespace std;
  mpol_t p0("x1+x2+1"), p1("x2+x1^2+1");
  cout<<p0<<", "<<p1<<endl;
  //| p0 = x1 + x2 + 1, p1 = x1^2 + x2 + 1

  mpol_t p2(p0+p1); cout<<p2<<endl;p2+=p1-p0; cout<<p2<<endl;
  //| x1^2 + x1 + 2*x2 + 2

  p2+=p1-p0; cout<<p2<<endl;
  //| 2*x1^2 + 2*x2 + 2

  p2 =p0-p1; cout<<p2<<endl;
  //| -x1^2 + x1

  p2=p0 -p1*mon_t(2); cout<<p2<<endl;
  //| - 2*x1^2 + x1 - x2 - 1
}

