
//#include"superLU/dgstrf.c"
//#include"superLU/convert.cc"

#include <synaps/init.h>


__BEGIN_NAMESPACE_SYNAPS

template<typename T>
void LUdecomp(sparse::rep2d<T> &m,sparse::rep2d<T> *L,sparse::rep2d<T> *U,int **pr,int **pc)
{
   //bon les nombres sojnt les bons 
  //etree je sais pas ce que c
  //perm_r et perm_c sont des output parce qu'on travail pas 
  //en sequence 
  //affdebug(m);
  static int flag=1;
  SuperMatrix<T> tmpM,tmpL,tmpU,AC;
  T diag_piv_thres=1;
  int * etree=(int*)malloc(sizeof(int)*(m.ncol));
  int *perm_c=(int*)malloc(sizeof(int)*m.ncol);
  int *perm_r=(int*)malloc(sizeof(int)*m.nrow);
  static int *info=(int*)malloc(sizeof(int));
  static char *refact=(char*)malloc(1);
  static int relax=sp_ienv(2);//par defaut ca vaut 5
  static int panel_size=sp_ienv(1);//par defaut ca vaut 10
  //int tps=clock();
  int lwork=0;
  ///cout<<"panel size "<<panel_size<<endl;
  cout<<"entre M:"<<endl;
  //affdebug(m);
  *refact='N';
  if (flag)
    {
      flag=0;
      StatInit(panel_size,relax);
    }
  dCreate_CompCol_Matrix(&tmpM, m.nrow, m.ncol, m.nnz,
			 (T*)m.nzval, m.rowind, m.colptr, NC, Pht_D, GE);
  get_perm_c(0,&tmpM,perm_c);
  //for(unsigned int i=0;i<m.ncol;i++)
  // cout<<"perm_c["<<i<<"] "<<(perm_c)[i]<<endl;
  sp_preorder(refact,&tmpM,perm_c,etree,&AC);
  cout<<"dans dgstrf "<<endl;
  dgstrf(refact,&AC,diag_piv_thres,0,relax,panel_size,
	 etree,NULL,lwork,perm_r,perm_c,&tmpL,&tmpU,info);
  //cout<<"temps dans dgstrf"<<(clock()-tps)/1000000.0<<endl;
  //dPrint_CompCol_Matrix(" M ",&tmpM);
  //dPrint_CompCol_Matrix("U ",&tmpU);
  //dPrint_SuperNode_Matrix(" L ",&tmpL);
  if (*info!=0) {cerr<<"dgstrf failed info "<<*info<<endl; /*abort();*/}
  *pr=perm_r;*pc=perm_c;
  LUConverttoNC(tmpM,tmpL,tmpU);
  //maintenant il faut recreer les sparse a partir de 
  //mes Supermetrix et desallouer les Store
  //mais pas les pointeur dedans !!!!
  destroystore(AC);
  m.destroystore();
  //free(m.nzval);
  //free(m.colptr);
  //free(m.rowind);
  free(tmpM.Store);
  m.rowind=((NCformat*)(tmpU.Store))->rowind;
  m.nzval=((NCformat*)(tmpU.Store))->nzval;
  m.colptr=((NCformat*)(tmpU.Store))->colptr;
  m.nnz=((NCformat*)(tmpU.Store))->nnz;
  free(tmpU.Store);
  L->rowind=((NCformat*)(tmpL.Store))->rowind;
  L->nzval=((NCformat*)(tmpL.Store))->nzval;
  L->colptr=((NCformat*)(tmpL.Store))->colptr;
  L->nrow=tmpL.nrow;
  L->ncol=tmpL.ncol;
  L->nnz=((NCformat*)(tmpL.Store))->nnz;
  free(tmpL.Store);
  //free(tmpL);
  // free(tmpU);
  free(etree);
  //for(unsigned int i=0;i<m.nrow;i++)
  //  cout<<"dans LUdecomp pr avant inverse pr["<<i<<"] "<<(*pr)[i]<<endl;
  inverse(*pr,m.nrow);
  //for(unsigned int i=0;i<m.nrow;i++)
  //  cout<<"dans lu decomp pr apres inverse pr["<<i<<"] "<<(*pr)[i]<<endl;
  // for(unsigned int i=0;i<m.ncol;i++)
  //   cout<<"pc avant inverse pc["<<i<<"] "<<(*pc)[i]<<endl;
  inverse(*pc,m.ncol);
  //  cout<<"M :"<<endl;
  //affdebug(m);
  //cout<<"L "<<endl;
  //affdebug(*L);
   //  Pour le moment parce que je sais pas tres bien ce que ca represente 
  return;
}


__END_NAMESPACE_SYNAPS

