
#include <synaps/init.h>


__BEGIN_NAMESPACE_SYNAPS

//retourne 1 si m1|m2 0 sinon
template<typename mon,typename Base>
int isdivisible(const mon & m1,const mon & m2,const Base & b)
{
  const int nbvar=b.nbvar();
  int res=1;
  for(int i=0;i<nbvar;i++)
    {
      //cout<<"    isdivisble  "<<m2.GetDegree(i)<<" "<<m1.GetDegree(i)<<endl;
      if(m2[i]<m1[i])
      { res=0;break;};
    }
  return res;
}
template<template<typename T,typename toto> class mon,typename typcoeff,
  char X,int d,typename T,typename Base>
int isdivisible(const mon<typcoeff,numexp<X,d,T> > & m1
		,const mon<typcoeff,numexp<X,d,T> > & m2,const Base & b)
{
  static int initmask=0;
  const int nbvar=b.nbvar();
  int res=1;
  T mask;
  
  if(initmask==0)
    {
      for(int i=0;i<d;i++) initmask=(initmask<<1)+1;
    }
  mask=initmask;
  for(int i=0;i<nbvar;i++)
    {

      if((m2.rep().ind&(mask))<(m1.rep().ind&(mask)))
	{ res=0;break;};
      mask=mask<<d;
    }
  return res;
}

__END_NAMESPACE_SYNAPS


