
#include <synaps/init.h>


__BEGIN_NAMESPACE_SYNAPS


template<typename typPk,typename typdump,typename Base,typename typserv> 
void rewrite(typPk &Pk,const typdump &dump,const Base &b,typserv &serv)
{
  typedef typename typPk::value_type polyalp;
  typedef typename polyalp::monom_t mon;
  typedef typename typdump::value_type dumpstruct;
  typedef typename dumpstruct::pol_t pol;
  typename typPk::iterator iter=Pk.begin();
  //cout<<"Pk.size dans rewrite "<<Pk.size()<<endl;
  for(;iter!=Pk.end();iter++)
    //pour chaque poly de Pk
    { 
      polyalp tmp(mon(0));
      for(typename polyalp::iterator itermon=iter->begin();
	  itermon!=iter->end();itermon++)
      //pour chaque mon du polynome *iter
      {
	  if (!IsinB(*itermon,b))
	    {
	      pol ttmp;
	      ttmp.size=-1;
	      ttmp.nf=NULL;
	      //cout<<"findcorresppol "<<*itermon<<endl;
	      findcorresppol(*itermon,dump,ttmp);
	      //cout<<"invconv"<<endl;
	      //fincorresppol ne touche pas son parametre de sortie qd 
	      //le monome recherche n'existe pas
	      //il existe ce monome?
	      if(ttmp.size!=-1)
		{
		  //  cout<<"trouve "<<endl;
		  //tmp*=mon(ttmp.ind.GetCoeff());
		  typename pol::coeff_t stock=itermon->coeff();
		  stock/=ttmp.ind.coeff();
		  tmp+=invconv<polyalp>(ttmp,serv)*mon(stock);
		}
		}
	
      }
      //cout<<"le pol que je vais enlever"<<endl;
      //cout<<tmp<<endl;
      //cout<<"fin du pol"<<endl;
      //cout<<"le poly avant reecriture "<<*iter<<endl;
      (*iter)-=tmp;
      //cout<<"poly apres reecriture!!\n"<<(*iter)<<endl;
    }
  return;
}

template<typename T,typename typdump,typename Base,typename typserv> 
void proj(T &Crochet,const typdump &dump, const Base &b, typserv & serv)
{
  typedef typename T::value_type polyalp;
  typedef typename polyalp::monom_t mon;
  typedef typename mon::coeff_t coeff;
  typename T::iterator iter=Crochet.begin();
  for(;iter!=Crochet.end();iter++)
    {
		std::list<mon> monared;
      //cout<<"le pol que je vais reduire"<<endl;
      //cout<<*iter<<endl;
      for(typename polyalp::iterator iterpol=iter->begin();iterpol!=iter->end();iterpol++)
	{
	  if (!IsinB(*iterpol,b)) monared.push_back(*iterpol);
	  //cout<<"mon dans proj "<<*iterpol<<" b? "<<IsinB(*iterpol,b)<<endl;
	}
      for(typename std::list<mon>::iterator itermon=monared.begin();itermon!=monared.end();itermon++)
	{
	  //  cout<<"dans le for sur monared "<<b.nbvar()<<endl;
	  polyalp result(1);
	  for(int i=0;i<b.nbvar();i++)
	    for(unsigned j=0;j<(*itermon)[i];j++)
	      {
		result*=mon(i,1);
		int flag=0;
		//cout<<"nbtour dans la boucle "<<itermon->GetDegree(i)<<"J"<<j<<endl;
		for (typename polyalp::iterator iterres=result.begin();
		     iterres!=result.end();iterres++)
		 {
		   if (!IsinB(*iterres,b)) flag=1;
		   // cout<<"IsinB("<<*iterres<<") "<<IsinB(*iterres,b)<<endl;
		 }
		if (flag)
		  {
		    T tmp;
		    tmp.push_back(result);
		    //cout<<"rewrite"<<endl;
		    rewrite(tmp,dump,b,serv);
		    //cout<<"sortie rewrite"<<endl;
		    result=*tmp.begin();
		  }
	      }
	  coeff Coeff;
	  for(typename polyalp::iterator iterpol=iter->begin();
	      iterpol!=iter->end();iterpol++)
	    if ((itermon->rep())==(iterpol->rep()))
	      {
		Coeff=iterpol->coeff();
		break;
	      }
	  //cout<<"iter avant reecriture "<<*iter<<endl;
	  *iter+=result*mon(Coeff);
	  *iter-=polyalp(mon((*itermon)*(coeff)(Coeff/itermon->coeff())));
	  //cout<<"iter apres reecriture "<<*iter<<endl<<endl;
	}
    }
  //stab(Crochet);
  return;

}



__END_NAMESPACE_SYNAPS



