#include <synaps/mpol/MPolDse.h>
#include <synaps/msolve/sbdslv.h>

typedef MPolDse<double, mpoldse::bernstein<double> > Bernstein;
typedef MPol<double>                                 Monoms;
int main()
{
  {
    //    Monoms p("u^2+v^2-1");
    //    Monoms q("u-0.4");
    //    Bernstein B[2] = { Bernstein(p), Bernstein(q) };
    std::vector<double> dmn(4);
    dmn[0] = -0.1; dmn[1] = 1;
    dmn[2] = -0.1; dmn[3] = 1;
    //    dmn[4] = -0.1; dmn[5] = 1;
    MPol<double> a("u^2+v^2-1");
    MPol<double> b("u-0.4");
    Seq<MPol<double> > pols;
    pols.push_back(a);
    pols.push_back(b);
    //    pols.push_back(c);
    
    std::cout << solve( pols, SBDSLV< double,SBDSLV_RDL >(1e-3), dmn ) << std::endl;
    //    std::cout << Solve( pols, SBDSLV< double, std::vector<double>, SBDSLV_RDS >(dmn) ) << std::endl;
    //    std::cout << Solve( pols, SBDSLV< double, std::vector<double>, SBDSLV_RD  >(dmn) ) << std::endl;
    
    std::cout << "fini\n";
  }
  
};
