#ifndef SYNAPS_SHAPE_BASIS_H
#define SYNAPS_SHAPE_BASIS_H
#include <synaps/linalg/MatrDse.h>

namespace geometry
{
  template<class C, int dim, int size_>
  struct point 
  {
    static const int dimension = dim;
    static const int size      = size;
  };

  template<class C, int d, int s>
  void add( vector<C,d,s>& a, const vector<C>& b, const vector<C>& c ) { for ( int i = 0; i < d; a[i] = b[i]+c[i], i ++ ); };
  template<class C, int d, int s>
  void sub( vector<C>& a, const vector<C>& b, const vector<C>& c ) { for ( int i = 0; i < d; a[i] = b[i]-c[i], i ++ ); };

  template<class C, int dim, int size_>
  struct vector : point<C,dim,size_>
  {
    static const int dimension = dim;
    static const int size      = size;
  };
  
  
  
  template<class C>
  struct K
  {
    typedef vertex<
  };
};

template<class C>
struct AffineFrame
{
  typedef fxmat<C,4,4> matrix_t;
  typedef fxv  <C,4>   vector_t;
  fxmat<C,4,4> m_basis;
  
  typedef C        coord_t;
  Basis()  : m_basis(4,4) {};
  static  Basis<C> world;  
};

template<class C>
void to_frame( Point & frame, const AffineFrame<C> & R, const Point& world )
{
  
};

template<class C> Basis<C>::world(1,0,0,0,
				  0,1,0,0,
				  0,0,1,0);


//  R  -T x 
//  0   1 y
//        z  

template<class C> 
void to_basis( BasisPoint & bp, const WorldPoint & wp )
{
  
};



template<class C>
struct ShapeRep
{
};

template<class R>
void ToWorld

#endif
