#ifndef SYNAPS_SHAPE_IGLGOOD_H
#define SYNAPS_SHAPE_IGLGOOD_H

#include <synaps/init.h>
#include <synaps/base/type.h>
__BEGIN_NAMESPACE_SYNAPS

struct IGLGood 
{
  typedef type::null_t base_t;
  enum { E_VERTEX, E_LINE, E_TRIANGLE, E_QUAD };
  int      type;
  int      nbv;
  int      nbi;
  double * vertices;
  double * normals ; // can be zero
  int    * indexes ; 
  IGLGood( int type, int nbv, int nbi, bool hasnormal = false ) ;
  virtual ~IGLGood();
};

__END_NAMESPACE_SYNAPS

#endif
