#include <algorithm>
#include <synaps/shape/gmv/stream.h>

__BEGIN_NAMESPACE_SYNAPS

namespace gmv
{
  void stream::points( const float * src, unsigned nv )
  {
    if ( m_binary )
      {
	fprintf(m_fd,"{ = OFF BINARY\n");
	unsigned * data = new unsigned [3+6*nv];
	data[0] = nv;
	data[1] = nv;
	data[2] = nv;
	float * pts = (float*)(data + 3);
	std::copy(src,src+3*nv,pts);
	unsigned * idx = data + 3 + 3*nv;
	for ( unsigned i = 0; i < nv; i ++, idx += 3 )
	  {
	    idx[0] = 1;
	    idx[1] = i;
	    idx[2] = 0;
	  };
	swab4(data,3+6*nv);
	fwrite(data,4,3+6*nv,m_fd);
	fprintf(m_fd,"}\n");
	delete[] data;
      }
    else
      {
	fprintf(m_fd," { = OFF\n");
	fprintf(m_fd,"%i %i %i\n", nv, nv, nv );
	for ( unsigned i =0; i < nv; i ++ )
	  fprintf(m_fd,"%f %f %f\n", (src+i*3)[0], (src+i*3)[1], (src+i*3)[2] );
	for ( unsigned i = 0; i < nv; i ++ )
	  fprintf(m_fd,"%i %i %i\n", 1, i, 0);
	fprintf(m_fd," }\n");
      };
  };
}
__END_NAMESPACE_SYNAPS

