


#ifndef SYNAPS_AK_GLOBAL_FUNCTIONS_2_H
#define SYNAPS_AK_GLOBAL_FUNCTIONS_2_H

#include <synaps/init.h>


__BEGIN_NAMESPACE_SYNAPS


template < class AK,
	   class OutputIterator >
inline
OutputIterator
solve( const typename AK::Polynomial_for_circles_2_2 & e1,
       const typename AK::Polynomial_for_circles_2_2 & e2,
       OutputIterator res )
{
  return AK().solve_object()(e1, e2, res);
}


template < class AK >
inline
typename AK::Polynomial_for_circles_2_2
construct_polynomial_cicle_2_2( const typename AK::RT& xc,
				const typename AK::RT& yc,
				const typename AK::RT& r_sq)
{
  return AK().construct_polynomial_circle_2_2_object()(xc, yc, r_sq);
}


__END_NAMESPACE_SYNAPS

#endif  // SYNAPS_AK_GLOBAL_FUNCTIONS_2_H
