// Copyright (c) 2003  INRIA Sophia-Antipolis (France) and
//                     Department of Informatics and Telecommunications
//                     University of Athens (Greece).
// All rights reserved.
//
// Authors : Elias P. TSIGARIDAS <et@di.uoa.gr>

// Partially supported by INRIA's project "CALAMATA", a
// bilateral collaboration with National Kapodistrian University of
// Athens.
// Partially supported by the IST Programme of the EU as a Shared-cost
// RTD (FET Open) Project under Contract No  IST-2000-26473
// (ECG - Effective Computational Geometry for Curves and Surfaces)


#ifndef  SYNAPS_ARITHM_ALGEBRAIC_COMPARISON_AUTO_RESULT_DEG_LENGTH_2_HH
#define  SYNAPS_ARITHM_ALGEBRAIC_COMPARISON_AUTO_RESULT_DEG_LENGTH_2_HH


#include <synaps/usolve/algebraic/Algebraic_config.h>

__ALGEBRAIC_BEGIN_NAMESPACE


class Result_deg_2 {
	public:
	static const int  degResult[16];
	static int on_end(const int& i);
}; // end of Class




__ALGEBRAIC_END_NAMESPACE

#endif //  SYNAPS_ARITHM_ALGEBRAIC_COMPARISON_AUTO_RESULT_DEG_LENGTH_2_HH




