// Copyright (c) 2003  INRIA Sophia-Antipolis (France) and
//                     Department of Informatics and Telecommunications
//                     University of Athens (Greece).
// All rights reserved.
//
// Authors : Elias P. TSIGARIDAS <et@di.uoa.gr>

// Partially supported by INRIA's project "CALAMATA", a
// bilateral collaboration with National Kapodistrian University of
// Athens.
// Partially supported by the IST Programme of the EU as a Shared-cost
// RTD (FET Open) Project under Contract No  IST-2000-26473
// (ECG - Effective Computational Geometry for Curves and Surfaces)





#include <synaps/usolve/algebraic/comparison/auto/Result_deg_length_2.h>


__ALGEBRAIC_BEGIN_NAMESPACE

int Result_deg_2::on_end(const int& i)
{
	return degResult[i];
}



const int Result_deg_2::degResult[16] = {
		0, -1, -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  0
	};
__ALGEBRAIC_END_NAMESPACE
