#include <iostream>
#include <synaps/arithm/gmp.h>
#include <synaps/usolve/Sturm.h>

using std::cout;
using std::cin;
using std::endl;

typedef ZZ NT;
typedef Sturm<ZZ> SOLVER;

typedef SOLVER::RT         RT;
typedef SOLVER::FT         FT;

typedef SOLVER::Poly       Poly;

typedef SOLVER::RO_t       RO_t;


typedef UPolDse<ZZ> UPoly;

int main()
{
  Poly f1(4, AsSize());
  f1[3] = 1;
  f1[2] = 2;
  f1[1] = -65;
  f1[0] = -150;

  std::cout <<f1<<std::endl;
  std::cout<< solve(f1, Sturm<ZZ>()) << std::endl;

}


