/*******************************************************************
 *   This file is part of the source code of the SYNAPS kernel.
 *   Author(s): J.P. Pavone, GALAAD, INRIA
 *   $Id: View.h,v 1.1 2005/10/04 12:30:09 mourrain Exp $
 ********************************************************************/
#ifndef synaps_traits_View_H
#define synaps_traits_View_H
//====================================================================
#include <synaps/init.h>
//====================================================================
__BEGIN_NAMESPACE_SYNAPS 
//====================================================================

struct ID
{
  int id;
  ID(): id(-1){};
};

template<class Rep>
struct View : ID// Vue (compile-time)
{
  static int CID;
  Rep a;
  View() { ((ID*)this)->id = CID; };
  Rep & rep(){ return a; };
  const Rep & rep() const { return a; };
};

template<class R> int View<R>::CID = -1;

//====================================================================
__END_NAMESPACE_SYNAPS 
#endif //
