#ifndef SYNAPS_BASE_TYPE_H
#define SYNAPS_BASE_TYPE_H

#include <synaps/init.h>
#include <iostream>
#include <sstream>
#include <cxxabi.h>
#include <typeinfo>
#include <vector>

#include "type/strip-qualifiers.h"
#include "type/tests.h"
#include "type/demangle.h"
#include "type/list.h"
#include "type/container-traits.h"
#include "type/computations.h"

__BEGIN_NAMESPACE_SYNAPS

namespace type {
  
  template < typename T >
  struct As {
    typedef T self_t;
  };
  struct AsSize {};  
};



/** 
 * @brief These functions check the validity of a tag. 
 * 
 * @param Tag_true 
 * 
 * @return true
 */
//inline bool check_type( type::true_t ) { return true;  }

/** 
 * @brief These functions check the validity of a tag. 
 * 
 * @param Tag_false 
 * 
 * @return false
 */
//inline bool check_type( type::false_t ) { return false; }

__END_NAMESPACE_SYNAPS

#endif
