#include <synaps/mpol/MPol.h>

typedef MPol<double> mpol_t;


mpol_t shifteval(const mpol_t & p, double s)
{
  mpol_t r;
  for(mpol_t::const_iterator it =p.begin(); it != p.end();++it)
    {
      mpol_t::monom_t m(it->coeff()*(pow(s,(int)(*it)[0])),2,(*it)[1]);
      if(m != 0) r += m;
    }

  return r;
}


int main(int argc, char** argv) 
{
  using std::cout;
  using std::endl;
  mpol_t p("s^2+2*t^2+1"), tmp("u");
  cout<<p<<endl;
  cout<<shifteval(p,1)<<endl;
}
