#include <synaps/solve/sbdslv.h>
#include <synaps/parametric/rational_surface.h>
#include <synaps/viewer/geomview/parametric.h>
#include <synaps/affine/point_set.h>
#include <synaps/viewer/geomview/point_set.h>


typedef MPol<double> mpol_t;
typedef rational::surface<double> surf_t;
typedef affine::point<double>     point_t;
typedef affine::point_set<double> ptset_t;

mpol_t shifteval(const mpol_t & p, double s)
{
 ...
}

Seq<mpol_t> System(const surf_t & P1, const surf_t & P2, double v)
{
 ...
}

void  add(ptset_t& sol,
	  const MatrDse<double>& M, const surf_t& s)
{
  ...
}

ptset_t inter(const surf_t& s1, const surf_t& s2)
{ 
  ...
}

int main(int argc, char** argv) 
{
  using std::cout;
  using std::endl;
  surf_t s1("s^2+t^2+1", "s-1+t^2", "s^2", "t^2", -1, 1.1);
  cout<<s1<<endl;
  surf_t s2("s^2+t^2+1", "s*t-1", "t^2", "1-s^2", -1, 1, -1, 1);
  cout<<s2<<endl;


  ptset_t S=  inter(s1,s2);

  geomview::ostream vw("tmp");
  vw<<s1;
  geomview::print(vw,s2,0.1,0.1,0.9);
  vw <<S;
  vw.view();
  
}
