#ifndef SYNAPS_LINALG_METHODNAME_H
#define SYNAPS_LINALG_METHODNAME_H

#include <synaps/init.h>

__BEGIN_NAMESPACE_SYNAPS


/*{ Names that are used to specify the method to be used }*/
///
struct Gauss  {};
///
struct Bareiss {};
///
struct LU {};
/// 
struct DU {};
/// 
struct LS {
  char dst;
  LS(char i='a'):dst(i){}
};
///
struct QR {};
///
struct Eigen {};
///
struct GMres {};
///
struct Mixed {};
///
struct Berko {};
//---------------------------------------------------------------------
struct ByRow {};
struct ByCol {};
struct ByHgt {};
//---------------------------------------------------------------------
struct Lower {};
struct Upper {};
//---------------------------------------------------------------------


__END_NAMESPACE_SYNAPS


#endif // SYNAPS_LINALG_METHODNAME_H
