//#include "f2c.h"

#undef abs
#include "math.h"
extern double f__cabs(double, double);
template<typename T>
void z_sqrt(complexdouble<T> *r, complexdouble<T> *z)
{
	T mag, zi = z->i, zr = z->r;

	if( (mag = sqrt(zr*zr+zi*zi)) == (T)0.)
		r->r = r->i = (T)0.;
	else if(zr > 0)
		{
		r->r = sqrt((T)0.5 * (mag + zr) );
		r->i = zi / r->r / (T)2;
		}
	else
		{
		r->i = sqrt((T)0.5 * (mag - zr) );
		if(zi < 0)
		  r->i *= -1;// r->i;
		r->r = zi / r->i / (T)2;
		}
	}
