#include <synaps/mpol.h>

typedef MPol<double> mpol_t;
int main(int argc, char** argv) 
{
  Variables V("u v");
  mpol_t p("u^2+v*u-v+2*u-1",V);
  std::cout << p<< std::endl;
  //| x0^2+x0*x1+2*x0-x1-1

  std::cout<<V[0]<<std::endl;
  //| u
  std::cout<<V[1]<<std::endl;
  //| v

  MPol<double> q("u^3-w+t", V); 
  std::cout<<V[2]<<std::endl;
  //| w
  std::cout<<V[3]<<std::endl;
  //| t
  std::cout<<V[4]<<std::endl;
  //| x4

  Variables W("a b c d");
  print(std::cout,p,W)<<std::endl;
  //| a^2+a*b+2*a-b-1
  print(std::cout,p)<<std::endl;
  //| x0^2+x0*x1+2*x0-x1-1
}
