#define USING_NAMESPACE_SYNAPS 1
#include <iostream>
#include "synaps/mpol/MPol.h"
#include "synaps/mpol/Lex.h"
#include "synaps/mpol/subs.h"


typedef MPol<double>      mpol_t;
//typedef MPol<double,Lex>  mpol_lex_t;

typedef mpol_t::monom_t Mon;

int main (int argc, char **argv)
{
  using std::cout;
  using std::cin;
  using std::endl;


  mpol_t p0("3*x1+7*x2+1;");
  mpol_t p1("x1^2+x2^2+x1-1;");
  cout<<"p0 = "<<p0<<endl<<"p1 = "<<p1<<endl;
  cout<<"subs "<<subs(2, mpol_t("x3-x0"),p0)<<endl;
  cout<<"subs "<<subs("x2",-1.1,p0)<<endl;
  //  cout<<"p1 = "<< mpol_lex_t(p1)<<endl;

  mpol_t p2(p0+p1);         cout<<p2<<endl;
  p2+=p1-p0;             cout<<p2<<endl;
  p2 =p0-p1;             cout<<p2<<endl;
  p2=p0-(p0+p1);         cout<<p2<<endl;
  p2=p0*p1;              cout<<p2<<endl;
  p2=p0 +p1*2.;          cout<<p2<<endl;
  p2=p0 -p1* Mon(2);     cout<<p2<<endl;
  p2=(p1+p0)*(p1-p0*2.); cout<<p2<<endl;
  p1=p2/p0;              cout<<p1<<endl;

  cout<<(p1+p0)*p1<<endl;

  cout <<diff(p1,"x2")<<endl;
}
