#define USING_NAMESPACE_SYNAPS 1

#include <list>
#include "synaps/mpol/MPol.h"
#include "synaps/mpol/matrixof.h"
#include "synaps/linalg.h"

using std::cout;
using std::cin;
using std::endl;

typedef MPol<double> Pol;
typedef VectDse<double> Vect;

int main (int argc, char **argv)
{
  unsigned n=3;
  linalg::rep1d<Pol> l(n);

  l[0] = Pol("x0^2-1");
  l[1] = Pol("2*x1^2+2*x0*x1+2");
  l[2] = Pol("2*x2^2+3*x01x1+3");

  cout <<matrix_of< MatrSps<double> > (l)<<endl;
}
