/**********************************************************************
 *   This file is part of the source code of the SYNAPS library.      *
 *   Author(s): H. Khalil, B. Mourrain, GALAAD, INRIA                 *
 *   $Id: method_name.h,v 1.3 2005/09/28 06:30:39 mourrain Exp $
 **********************************************************************/
#ifndef synaps_solve_method_name_H
#define synaps_solve_method_name_H

#include <synaps/init.h>
#include <synaps/usolve/algebraic/Algebraic_config.h>
#include <synaps/usolve/algebraic/root_of.h>
#include <synaps/usolve/algebraic/Method_name.h>
//#include <synaps/solve/bezier/Bounding.h>
//#include <synaps/algebraic/Apx_root_of.h>
//#include <synaps/algebraic/Filt_root_of.h>
#include <synaps/usolve/bezier/Bezier.h>

__BEGIN_NAMESPACE_SYNAPS


template<class S> struct Habicht
{
  typedef S solver_t;
};

__END_NAMESPACE_SYNAPS
#endif // synaps_solve_method_name_H

