#ifndef SYNAPS_SHAPE_ALGEBRAICSURFACE_H
#define SYNAPS_SHAPE_ALGEBRAICSURFACE_H

#include <synaps/shape/interfaces/IShape.h>

__BEGIN_NAMESPACE_SYNAPS

struct IAlgebraicSurface
{
  // setDefinition( "x^2+y^2+z^2", "x y z" )
  virtual void setDefinition( const char * eqn, const char * varnames ) = 0;
  virtual void extrema( std::vector< double > );
		      
};

__END_NAMESPACE_SYNAPS
#endif
