#include <synaps/shape/interfaces/IGLGood.h>
#include <synaps/shape/interfaces/IParametricCurve.h>
__BEGIN_NAMESPACE_SYNAPS

IGLGood::IGLGood( int t, int nbv, int nbi, bool hasnormal )
{
  this->type = t;
  this->nbv = nbv;
  this->nbi = nbi;
  vertices = new double[3*nbv];
  if ( hasnormal ) normals = new double[3*nbv];
  else             normals = 0;
  indexes = new int[nbi];
};
  
IGLGood::~IGLGood()
{
  if ( vertices ) delete[] vertices;
  if ( normals  ) delete[] normals;
  if ( indexes ) delete[] indexes;
};


__END_NAMESPACE_SYNAPS
