
#include <synaps/base/type.h>
#include <synaps/shape/interfaces/Interface.h>

#include <synaps/shape/interfaces/IShape.h>
#include <synaps/shape/interfaces/IParametricSurface.h>
#include<synaps/shape/interfaces/IBSplineSurface.h>
#include<synaps/shape/interfaces/IRationalSurface.h>
#include<synaps/shape/interfaces/IParametricCurve.h>
#include<synaps/shape/interfaces/IBSplineCurve.h>
#include<synaps/shape/interfaces/IRationalCurve.h>
#include<synaps/shape/interfaces/IImplicitSurface.h>
#include<synaps/shape/interfaces/IGLGood.h>


__BEGIN_NAMESPACE_SYNAPS

template<class I>
InterfaceInfo<I> Interface<I>::info;
int CInterfaceInfo::icount = 0;

#define interface_info(TYPENAME) int TYPENAME##_int = Interface< TYPENAME >::info.icount;

interface_info(IShape);
interface_info(IParametricSurface);
interface_info(IBSplineSurface);
interface_info(IRationalSurface);
interface_info(IParametricCurve);
interface_info(IBSplineCurve);
interface_info(IRationalCurve);
interface_info(IImplicitSurface);
interface_info(IAlgebraicSurface);
interface_info(IGLGood);


__END_NAMESPACE_SYNAPS
