#include <synaps/shape/curves/RationalCurve.h>
#include <synaps/shape/surfaces/RationalSurface.h>


int main(int argc, char** argv)
{

  RationalCurve<double> c;
  setEquations(c,"1", "x", "x^2", "x");
  std::cout<<c<<std::endl;

  RationalCurve<double> c2("x^2+1", "x", "x^2", "1");
  std::cout<<c2<<std::endl;

  RationalSurface<double> s;
  setEquations(s,"u^2", "u+v", "v^2*u-1", "v^3-1","u v");
  std::cout<<s<<std::endl;

  RationalSurface<double> s2("1", "u+v", "v^2*u-1", "v^3-1","u v");
  std::cout<<s2<<std::endl;

}
