#include <synaps/base/type.h>

__BEGIN_NAMESPACE_SYNAPS
namespace type
{
  template<class R>                          struct rep_         { typedef null_t T; };
  template<template<class> class V, class R> struct rep_< V<R> > { typedef R T;      };
  
  
  template<class O, class path>
  struct path_
  {
    typedef typename rep_<path>::T  A;
    typedef typename path_<O,A>::T L;
    typedef tlist<path,L> T;
  };
  template<class O>
  struct path_<O,O> { typedef  tlist<O,null_t> T; };
  template<class O>
  struct path
  {
    typedef typename path_<O,typename O::path_t>::T T;
  };
};
__END_NAMESPACE_SYNAPS

template<class R> 
struct Curve { R rep_; };

template<class R> 
struct Parametric  { R rep_; };

template<class R> 
struct Polynomial { R rep_; };

template<class R> 
struct Bezier { R rep_ ; };

template<class C> 
struct BezierCurve
{
  typedef BezierCurve<C> self_t;
  typedef Curve< Parametric< Polynomial< Bezier  < self_t > > > > path_t;
};


template<class R, class T> 
void f ( const R  & r, T )
{
  f( 
};

int main()
{
  std::cout << type::TYPE< type::path<BezierCurve<double> >::T > () << std::endl;
};
