/********************************************************************
 *      This file is part of the source code of SYNAPS kernel.
 *      Author(s): B. Mourrain, M. Racois, GALAAD, INRIA    
 *      History: First draft, BM. 28/05/2000.
 *        Cleaning adjacent box; M. Racois 24/07/2000.
 *      $Id: weierstrass.h,v 1.1 2005/07/11 10:03:52 jppavone Exp $
 ********************************************************************/
/** \file                                                          **/
#ifndef SYNAPS_WEIERSTRASS_H
#define SYNAPS_WEIERSTRASS_H
/********************************************************************/
#include "synaps/usolve/weierstrass/WeierTools.h"
#include "synaps/usolve/weierstrass/WeierIter.h"
#include "synaps/usolve/weierstrass/FileTools.h"

/********************************************************************/
#endif // SYNAPS_WEIERSTRASS_H
