// Copyright (c) 2003  INRIA Sophia-Antipolis (France) and
//                     Department of Informatics and Telecommunications
//                     University of Athens (Greece).
// All rights reserved.
//
// Authors : Elias P. TSIGARIDAS <et@di.uoa.gr>

// Partially supported by INRIA's project "CALAMATA", a
// bilateral collaboration with National Kapodistrian University of
// Athens.
// Partially supported by the IST Programme of the EU as a Shared-cost
// RTD (FET Open) Project under Contract No  IST-2000-26473
// (ECG - Effective Computational Geometry for Curves and Surfaces)

#include <synaps/usolve/algebraic/comparison/auto/Auto_Results.h>

__ALGEBRAIC_BEGIN_NAMESPACE
int to_CR(int i)
{
  switch (i) {
 		case 1:
 			return LARGER;
 		case 0:
 			return EQUAL;
 		case -1:
			return SMALLER;
		case -100:
			return UNKNOWN;
		default:
			return ERROR;
	}
} 

Result_length_3 Static_Result::Result_3;
Result_length_4 Static_Result::Result_4;
Result_length_5 Static_Result::Result_5;
Result_length_6 Static_Result::Result_6;


__ALGEBRAIC_END_NAMESPACE
